Index: orxonox/branches/levelloader/src/lib/graphics/importer/model.cc
===================================================================
--- orxonox/branches/levelloader/src/lib/graphics/importer/model.cc	(revision 3606)
+++ orxonox/branches/levelloader/src/lib/graphics/importer/model.cc	(revision 3746)
@@ -34,34 +34,4 @@
 {
   this->initialize();
-}
-
-/**
-   \brief Creates a 3D-Model of Primitive-Type type
-
-   if you want to just display a Cube/Sphere/Cylinder/... without any material.
-   
-   \todo implement Cube/Sphere/Cylinder/...
-*/
-Model::Model(PRIMITIVE type)
-{
-  this->initialize();
-
-  switch (type)
-    {
-    default:
-    case CUBE:
-      this->cubeModel();
-      break;
-    case SPHERE:
-      this->sphereModel();
-      break;
-    case CYLINDER:
-      this->cylinderModel();
-      break;
-
-    }
-  this->importToGL ();
-
-  this->cleanup();
 }
 
@@ -492,7 +462,7 @@
 
       tmpElem->vertexNumber = va_arg (itemlist, int) -1;
-      if (type >= 2)
+      if (type & TEXCOORD)
 	tmpElem->texCoordNumber = va_arg (itemlist, int) -1;
-      if (type == 1 || type ==3)
+      if (type & NORMAL)
  	tmpElem->normalNumber = va_arg(itemlist, int) -1;
       this->currentGroup->currentFace->vertexCount++;
@@ -797,52 +767,52 @@
 void Model::cubeModel(void)
 {
-  this->addVertex ("-0.5 -0.5 0.5");
-  this->addVertex ("0.5 -0.5 0.5");
-  this->addVertex ("-0.5 0.5 0.5");
-  this->addVertex ("0.5 0.5 0.5");
-  this->addVertex ("-0.5 0.5 -0.5");
-  this->addVertex ("0.5 0.5 -0.5");
-  this->addVertex ("-0.5 -0.5 -0.5");
-  this->addVertex ("0.5 -0.5 -0.5");
-
-  this->addVertexTexture ("0.0 0.0");
-  this->addVertexTexture ("1.0 0.0");
-  this->addVertexTexture ("0.0 1.0");
-  this->addVertexTexture ("1.0 1.0");
-  this->addVertexTexture ("0.0 2.0");
-  this->addVertexTexture ("1.0 2.0");
-  this->addVertexTexture ("0.0 3.0");
-  this->addVertexTexture ("1.0 3.0");
-  this->addVertexTexture ("0.0 4.0");
-  this->addVertexTexture ("1.0 4.0");
-  this->addVertexTexture ("2.0 0.0");
-  this->addVertexTexture ("2.0 1.0");
-  this->addVertexTexture ("-1.0 0.0");
-  this->addVertexTexture ("-1.0 1.0");
-
-  this->addVertexNormal ("0.0 0.0 1.0");
-  this->addVertexNormal ("0.0 0.0 1.0");
-  this->addVertexNormal ("0.0 0.0 1.0");
-  this->addVertexNormal ("0.0 0.0 1.0");
-  this->addVertexNormal ("0.0 1.0 0.0");
-  this->addVertexNormal ("0.0 1.0 0.0");
-  this->addVertexNormal ("0.0 1.0 0.0");
-  this->addVertexNormal ("0.0 1.0 0.0");
-  this->addVertexNormal ("0.0 0.0 -1.0");
-  this->addVertexNormal ("0.0 0.0 -1.0");
-  this->addVertexNormal ("0.0 0.0 -1.0");
-  this->addVertexNormal ("0.0 0.0 -1.0");
-  this->addVertexNormal ("0.0 -1.0 0.0");
-  this->addVertexNormal ("0.0 -1.0 0.0");
-  this->addVertexNormal ("0.0 -1.0 0.0");
-  this->addVertexNormal ("0.0 -1.0 0.0");
-  this->addVertexNormal ("1.0 0.0 0.0");
-  this->addVertexNormal ("1.0 0.0 0.0");
-  this->addVertexNormal ("1.0 0.0 0.0");
-  this->addVertexNormal ("1.0 0.0 0.0");
-  this->addVertexNormal ("-1.0 0.0 0.0");
-  this->addVertexNormal ("-1.0 0.0 0.0");
-  this->addVertexNormal ("-1.0 0.0 0.0");
-  this->addVertexNormal ("-1.0 0.0 0.0");
+  this->addVertex (-0.5, -0.5, 0.5);
+  this->addVertex (0.5, -0.5, 0.5);
+  this->addVertex (-0.5, 0.5, 0.5);
+  this->addVertex (0.5, 0.5, 0.5);
+  this->addVertex (-0.5, 0.5, -0.5);
+  this->addVertex (0.5, 0.5, -0.5);
+  this->addVertex (-0.5, -0.5, -0.5);
+  this->addVertex (0.5, -0.5, -0.5);
+
+  this->addVertexTexture (0.0, 0.0);
+  this->addVertexTexture (1.0, 0.0);
+  this->addVertexTexture (0.0, 1.0);
+  this->addVertexTexture (1.0, 1.0);
+  this->addVertexTexture (0.0, 2.0);
+  this->addVertexTexture (1.0, 2.0);
+  this->addVertexTexture (0.0, 3.0);
+  this->addVertexTexture (1.0, 3.0);
+  this->addVertexTexture (0.0, 4.0);
+  this->addVertexTexture (1.0, 4.0);
+  this->addVertexTexture (2.0, 0.0);
+  this->addVertexTexture (2.0, 1.0);
+  this->addVertexTexture (-1.0, 0.0);
+  this->addVertexTexture (-1.0, 1.0);
+
+  this->addVertexNormal (0.0, 0.0, 1.0);
+  this->addVertexNormal (0.0, 0.0, 1.0);
+  this->addVertexNormal (0.0, 0.0, 1.0);
+  this->addVertexNormal (0.0, 0.0, 1.0);
+  this->addVertexNormal (0.0, 1.0, 0.0);
+  this->addVertexNormal (0.0, 1.0, 0.0);
+  this->addVertexNormal (0.0, 1.0, 0.0);
+  this->addVertexNormal (0.0, 1.0, 0.0);
+  this->addVertexNormal (0.0, 0.0, -1.0);
+  this->addVertexNormal (0.0, 0.0, -1.0);
+  this->addVertexNormal (0.0, 0.0, -1.0);
+  this->addVertexNormal (0.0, 0.0, -1.0);
+  this->addVertexNormal (0.0, -1.0, 0.0);
+  this->addVertexNormal (0.0, -1.0, 0.0);
+  this->addVertexNormal (0.0, -1.0, 0.0);
+  this->addVertexNormal (0.0, -1.0, 0.0);
+  this->addVertexNormal (1.0, 0.0, 0.0);
+  this->addVertexNormal (1.0, 0.0, 0.0);
+  this->addVertexNormal (1.0, 0.0, 0.0);
+  this->addVertexNormal (1.0, 0.0, 0.0);
+  this->addVertexNormal (-1.0, 0.0, 0.0);
+  this->addVertexNormal (-1.0, 0.0, 0.0);
+  this->addVertexNormal (-1.0, 0.0, 0.0);
+  this->addVertexNormal (-1.0, 0.0, 0.0);
 
   /* normaleLess-testingMode
@@ -855,102 +825,10 @@
   */
 
-  this->addFace ("1/1/1 2/2/2 4/4/3 3/3/4");
-  this->addFace ("3/3/5 4/4/6 6/6/7 5/5/8");
-  this->addFace ("5/5/9 6/6/10 8/8/11 7/7/12");
-  this->addFace ("7/7/13 8/8/14 2/10/15 1/9/16");
-  this->addFace ("2/2/17 8/11/18 6/12/19 4/4/20");
-  this->addFace ("7/13/21 1/1/22 3/3/23 5/14/24");
-
-}
-
-/**
-   \brief Builds a Sphere into the Model
-*/
-void Model::sphereModel()
-{
-  int detail = 30;
-  if (detail <= 0) detail = 1;
-  float df = (float)detail;
-  for (float i = 0.0; i < df/2; i+=1.0)
-    {
-      for (float j = 0.0; j < df; j+=1.0)
-      {
-	float vz = i/df *2.0*PI - PI/2.0;
-	this->addVertex(cos(j/df*2.0*PI) * cos(vz) ,
-			sin(j/df*2.0*PI) * cos(vz),
-			sin(vz));
-	//if (j==0.0)
-	//printf ("%f %f\n", vz, sin (vz));
-	if (i==0.0)
-	  PRINTF(0)("%f, %f\n", j/df*2.0*PI, cos(j/df*PI));
-      }
-    }
-  vertices->debug();
-  for (int i = 0; i < detail/2; i++)
-    for (int j = 1; j < detail; j++)
-      {
-	unsigned int v1,v2,v3,v4;
-	v1 = i*detail +j;
-
-	/*	if (j+1 == detail)
-	  {
-	    v2 = i*detail +1;
-	    v3 = i*detail+detail + 1;
-	  }
-	  else*/
-	  {
-	    v2 = i*detail +j+1;
-	    v3 = i*detail+detail + j+1;
-	  }
-	v4 = i*detail+detail + j;
-	//printf("%i %i %i %i\n", v1, v2, v3, v4);
-	this->addFace(4, 0, v1, v2, v3, v4);
-      }
-}
-
-/**
-   \brief Creates a Cylinder.
-*/
-void Model::cylinderModel(void)
-{
-  unsigned int detail = 20;
-  float size = 1.0;
-
-  // check if devision by zero
-  if (detail <= 3)
-    detail = 3;
-  int count = 0;
-  // defining Points of the Cylinder.
-  for (float phi = 0.0; phi < 2.0*PI; phi += 2.0*PI/(float)detail)
-    {
-      this->addVertex(size*cos(phi), size*sin(phi), -size);
-      this->addVertex(size*cos(phi), size*sin(phi), size);
-      count ++;
-    }
-  this->addVertex(0, 0, -size);
-  this->addVertex(0, 0, size);
-
-  
-  if (count != detail)
-    PRINTF(1)("calculation error, count should be %d but is %d.\n", detail, count);
-  vertices->debug();
-
-  // adding Faces
-  for (int i = 0; i < detail-1; i++)
-    {
-      int p1, p2, p3, p4;
-      p1 = 2*i+1;
-      p2 = 2*i+2;
-      if (i <= detail);
-      p3 = 2*i+4;
-      p4 = 2*i+3;
-      // something is wrong here
-      this->addFace(4, 0, p1, p2, p3, p4);
-      this->addFace(3, 0, p4, p1, 2*detail+1);
-      this->addFace(3, 0, p2, p3, 2*detail+2);
-    }
-  addFace(4,0, 2*detail-1, 2*detail, 2, 1);
-  this->addFace(3, 0, 1, 2*detail-1, 2*detail+1);
-  this->addFace(3, 0, 2*detail, 2, 2*detail+2);
-
-}
+  this->addFace (4, 3, 1,1,1, 2,2,2, 4,4,3, 3,3,4);
+  this->addFace (4, 3, 3,3,5, 4,4,6, 6,6,7, 5,5,8);
+  this->addFace (4, 3, 5,5,9, 6,6,10, 8,8,11, 7,7,12);
+  this->addFace (4, 3, 7,7,13, 8,8,14, 2,10,15, 1,9,16);
+  this->addFace (4, 3, 2,2,17, 8,11,18, 6,12,19, 4,4,20);
+  this->addFace (4, 3, 7,13,21, 1,1,22, 3,3,23, 5,14,24);
+
+}
Index: orxonox/branches/levelloader/src/lib/graphics/importer/model.h
===================================================================
--- orxonox/branches/levelloader/src/lib/graphics/importer/model.h	(revision 3606)
+++ orxonox/branches/levelloader/src/lib/graphics/importer/model.h	(revision 3746)
@@ -15,6 +15,8 @@
 using namespace std;
 
-//! Specification of different primitives the Model knows
-enum PRIMITIVE {PLANE, CUBE, SPHERE, CYLINDER};
+// definition of different modes for setting up Faces
+#define VERTEX 0       //!< If Faces are created WITH Vertex-Coordinate
+#define NORMAL 1       //!< If Faces are created WITH Normals (otherwise autocalculate)
+#define TEXCOORD 2     //!< If Faces are created WITH TextureCoordinate
 
 //! Class that handles 3D-Models. it can also read them in and display them.
@@ -23,5 +25,4 @@
  public:
   Model(void);
-  Model(PRIMITIVE type);
   Model(char* modelName);
   virtual ~Model(void);
@@ -114,6 +115,4 @@
 
   void cubeModel(void);
-  void sphereModel(void);
-  void cylinderModel(void);
 };
 
Index: orxonox/branches/levelloader/src/lib/graphics/importer/objModel.cc
===================================================================
--- orxonox/branches/levelloader/src/lib/graphics/importer/objModel.cc	(revision 3606)
+++ orxonox/branches/levelloader/src/lib/graphics/importer/objModel.cc	(revision 3746)
@@ -21,19 +21,4 @@
 
 #include "debug.h"
-
-/**
-   \brief Crates a 3D-Model and loads in a File.
-   \param fileName file to parse and load (must be a .obj file)
-*/
-OBJModel::OBJModel(const char* fileName)
-{
-  this->initializeOBJ();
-
-  this->importFile (fileName);
-
-  this->importToGL ();
-
-  this->cleanup();
-}
 
 /**
@@ -193,5 +178,5 @@
       else if (!strncmp(Buffer, "s ", 2)) //! \todo smoothing groups have to be implemented
 	{
-	  PRINTF(3)("smoothing groups not supportet yet. line: %s\n", Buffer);
+	  PRINTF(2)("smoothing groups not supportet yet. line: %s\n", Buffer);
 	}
     }
@@ -200,5 +185,4 @@
   delete []fileName;
   return true;
-
 }
 
Index: orxonox/branches/levelloader/src/lib/graphics/importer/objModel.h
===================================================================
--- orxonox/branches/levelloader/src/lib/graphics/importer/objModel.h	(revision 3606)
+++ orxonox/branches/levelloader/src/lib/graphics/importer/objModel.h	(revision 3746)
@@ -13,6 +13,5 @@
 {
  public:
-  OBJModel(const char* fileName);
-  OBJModel(const char* fileName, float scaling);
+  OBJModel(const char* fileName, float scaling = 1.0);
   virtual ~OBJModel();
   void initializeOBJ(void);
@@ -28,5 +27,4 @@
   bool readFromObjFile (void);
   bool readMtlLib (const char* matFile);
-
 };
 
Index: orxonox/branches/levelloader/src/lib/graphics/importer/primitive_model.cc
===================================================================
--- orxonox/branches/levelloader/src/lib/graphics/importer/primitive_model.cc	(revision 3746)
+++ orxonox/branches/levelloader/src/lib/graphics/importer/primitive_model.cc	(revision 3746)
@@ -0,0 +1,242 @@
+/* 
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Benjamin Grauer
+   co-programmer: ...
+*/
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_WORLD_MODEL
+
+#include "primitive_model.h"
+
+#include <math.h>
+#include "vector.h"
+#include "debug.h"
+
+using namespace std;
+
+/**
+   \brief Creates a 3D-Model of Primitive-Type type
+
+   if you want to just display a Cube/Sphere/Cylinder/... without any material.
+   
+   \todo implement Cube/Sphere/Cylinder/...
+*/
+PrimitiveModel::PrimitiveModel(PRIMITIVE type, float size, unsigned int detail)
+{
+  this->initialize();
+
+  switch (type)
+    {
+    default:
+    case CUBE:
+      this->cubeModel();
+      break;
+    case SPHERE:
+      this->sphereModel(size, detail);
+      break;
+    case CYLINDER:
+      this->cylinderModel();
+      break;
+    case CONE:
+      this->coneModel(size, detail);
+      break;
+    case PLANE:
+      this->planeModel(size, detail);
+      break;
+    }
+  this->importToGL ();
+
+  this->cleanup();
+}
+
+/**
+   \brief standard deconstructor
+
+*/
+PrimitiveModel::~PrimitiveModel () 
+{
+  // delete what has to be deleted here
+}
+
+/**
+   \brief Builds a Sphere into the Model.
+   \param size The diameter of the Sphere.
+   \param detail The detail of the Sphere.
+*/
+void PrimitiveModel::sphereModel(float size, unsigned int detail)
+{
+  int vertexCount = 0;
+  if (detail <= 0) 
+    detail = 1;
+  size /= 2;
+  //  detail = 2; // make it even
+  float df = (float)detail;
+  
+  // defining the Vertices
+  for (float i = 0; i < df *2.0; i+=1.0)
+    {
+      float vi = i/df *PI;
+      for (float j = -df / 2.0 +1.0; j < df / 2.0; j+=1.0 *df/(df+1.0))
+	{
+	  float vj = j/df *PI;
+	  this->addVertex(size * cos(vi) * cos(vj),
+			  size * sin(vj),
+			  size * sin(vi) * cos(vj));
+	  this->addVertexTexture(i / (df *2.0), (j-1.0)/(df)+.5);
+	  vertexCount++;
+	}
+    }
+  this->addVertex(0, -size, 0);
+  this->addVertex(0, size, 0);
+
+  // defining the binding Faces.
+  unsigned int v1, v2, v3, v4;
+  for (int i = 0; i <= detail * 2 -1; i++)
+    {
+      for (int j = 0; j <= detail; j++)
+	{
+	  
+	  v1 = i*detail + j;
+	  v4 = i*detail + (j+1);
+	  
+	  if (i == detail*2 -1)
+	    {
+	      v2 = j;
+	      v3 = j+1;
+	    }
+	  else
+	    {
+	      v2 = (i+1)*detail + j;
+	      v3 = (i+1)*detail + (j+1);
+	    }
+	  
+	  if (j == 0)
+	    {
+	      v1 = vertexCount+1;
+	      this->addFace(3, TEXCOORD, v1, v1, v3, v3, v4, v4);
+	    }
+	  else if (j == detail)
+	    {
+	      v3 = vertexCount+2;
+	      this->addFace(3, TEXCOORD, v1, v1, v2, v2, v3, v3);
+	    }
+	  else
+	    this->addFace(4, TEXCOORD, v1, v1, v2, v2, v3, v3, v4, v4);
+	}
+    }
+}
+/**
+   \brief Creates a Cylinder.
+*/
+void PrimitiveModel::cylinderModel(float size, unsigned int detail)
+{
+  // check if devision by zero
+  if (detail <= 3)
+    detail = 3;
+  int count = 0;
+  // defining Points of the Cylinder.
+  for (float phi = 0.0; phi < 2.0*PI; phi += 2.0*PI/(float)detail)
+    {
+      this->addVertex(size*cos(phi), size*sin(phi), -size);
+      this->addVertex(size*cos(phi), size*sin(phi), size);
+      count ++;
+    }
+  this->addVertex(0, 0, -size);
+  this->addVertex(0, 0, size);
+
+  if (count != detail)
+    PRINTF(1)("calculation error, count should be %d but is %d.\n", detail, count);
+
+  // adding Faces
+  for (int i = 0; i < detail-1; i++)
+    {
+      int p1, p2, p3, p4;
+      p1 = 2*i+1;
+      p2 = 2*i+2;
+      if (i <= detail);
+      p3 = 2*i+4;
+      p4 = 2*i+3;
+      // something is wrong here
+      this->addFace(4, 0, p1, p2, p3, p4);
+      this->addFace(3, 0, p4, p1, 2*detail+1);
+      this->addFace(3, 0, p2, p3, 2*detail+2);
+    }
+  addFace(4,0, 2*detail-1, 2*detail, 2, 1);
+  this->addFace(3, VERTEX, 1, 2*detail-1, 2*detail+1);
+  this->addFace(3, VERTEX, 2*detail, 2, 2*detail+2);
+}
+
+/**
+   \brief creates a cone inside of this Model
+   \param size The size of the cone
+   \param detail the Detail-level of this cone
+*/
+void PrimitiveModel::coneModel(float size, unsigned int detail)
+{
+  this->addVertex(0,-size,0);
+  this->addVertex(0,size,0);
+  if (detail <= 0) 
+    detail = 1;
+  float df = (float)detail;
+  
+  // defining the Vertices
+  for (float i = 0; i < df; i+=1.0)
+    {
+      float vi = i/df *2.0*PI;
+      this->addVertex(size* sin(vi),
+		      -size,
+		      size* cos(vi));
+    }
+
+  //defining Faces
+  for (int i = 0; i < detail; i++)
+    {
+      unsigned int v1, v2;
+      v1 = i+3;
+      if (i == detail -1)
+	v2 = 3;
+      else
+	v2 = i+4;
+      this->addFace(3, VERTEX, 1, v1, v2);
+      this->addFace(3, VERTEX, 2, v1, v2); 
+    }
+}
+
+/**
+   \brief creates a Plane inside of this Model
+   \param size The size of this plane
+   \param detail the Detail-level of this plane.
+*/
+void PrimitiveModel::planeModel(float size, unsigned int detail)
+{
+  //defining vertices
+  for (int i = 0; i < detail; i++)
+    for (int j = 0; j < detail; j++)
+      {
+	this->addVertex(((float)i/(float)(detail-1) -.5)*size,
+			0,
+			((float)j/(float)(detail-1) -.5)*size);
+	this->addVertexTexture((float)i/(float)(detail-1),
+			       (float)j/(float)(detail-1));
+      }
+  //defining Faces
+  unsigned int v1, v2, v3, v4;
+  for (int i = 0; i < detail-1; i++)
+    for (int j = 1; j < detail; j++)
+      {
+	v1 = i*detail + j;
+	v2 = (i+1)*detail + j;
+	v3 = (i+1)*detail + (j+1);
+	v4 = i*detail + (j+1);
+	this->addFace(4, TEXCOORD, v1, v1, v2, v2, v3, v3, v4, v4);
+      }
+}
Index: orxonox/branches/levelloader/src/lib/graphics/importer/primitive_model.h
===================================================================
--- orxonox/branches/levelloader/src/lib/graphics/importer/primitive_model.h	(revision 3746)
+++ orxonox/branches/levelloader/src/lib/graphics/importer/primitive_model.h	(revision 3746)
@@ -0,0 +1,31 @@
+/*! 
+    \file primitive_model.h 
+    \brief a Class to handle different simple models like planes cubes spheres and so on.
+    (cube is also an option of Model, but is extended here.
+*/
+
+#ifndef _PRIMITIVE_MODEL_H
+#define _PRIMITIVE_MODEL_H
+
+#include "model.h"
+
+//! Specification of different primitives the Model knows
+enum PRIMITIVE {CUBE, SPHERE, PLANE, CYLINDER, CONE};
+
+// FORWARD DEFINITION \\
+
+//! A Class to create some default Models
+class PrimitiveModel : public Model {
+
+ public:
+  PrimitiveModel(PRIMITIVE type, float size = 1.0, unsigned int detail = 10);
+  virtual ~PrimitiveModel();
+
+ protected:
+  void sphereModel(float size = 1.0, unsigned int detail = 10);
+  void cylinderModel(float size = 1.0, unsigned int detail = 10);
+  void coneModel(float size = 1.0, unsigned int detail = 10);
+  void planeModel(float size = 1.0, unsigned int detail = 1);
+};
+
+#endif /* _PRIMITIVE_MODEL_H */
Index: orxonox/branches/levelloader/src/lib/graphics/importer/texture.cc
===================================================================
--- orxonox/branches/levelloader/src/lib/graphics/importer/texture.cc	(revision 3606)
+++ orxonox/branches/levelloader/src/lib/graphics/importer/texture.cc	(revision 3746)
@@ -22,98 +22,5 @@
 #include "texture.h"
 
-// headers only for PathList
-#include <unistd.h>
-#include <sys/types.h>
-#include <sys/stat.h>
-#include <stdlib.h>
-#include <fstream>
-
-/**
-   \brief creates a ned PathList.
-   
-   It is a good idea to use this as an initial List,
-   because if you give on a name the Path will not be checked for its existence.
-*/
-PathList::PathList()
-{
-  this->pathName = NULL;
-  this->next = NULL;
-}
-
-/**
-   \brief Creates a new PathList with a Name.
-   \param pName the Name of The Path.
-
-   This function just adds the Path without checking if it exists.
-*/
-PathList::PathList(char* pName)
-{
-  this->pathName = new char [strlen(pName)+1];
-  strcpy (this->pathName, pName);
-  this->next = NULL;
-}
-
-/**
-   \brief destroys a PathList
-
-   It does this by deleting the Name and then delete its preceding PathList.
-*/
-PathList::~PathList()
-{
-  if (this->pathName)
-    delete []this->pathName;
-  if (this->next)
-    delete this->next;
-}
-
-PathList* PathList::firstPath = NULL;
-
-/**
-   \returns A Pointer to the first Path of the Pathlist
-*/
-PathList* PathList::getInstance(void)
-{
-  if (firstPath)
-    return firstPath;
-  firstPath = new PathList();
-}
-/**
-   \brief Adds a new Pathlist Element.
-   \param pName
-   
-   Adding a Path automatically checks if the Path exists,
-   and if it does not it will not add it to the List.
-*/
-void PathList::addPath (char* pName)
-{
-  if (pName[0] == '\0')
-    {
-      PRINTF(2)("not Adding empty Path to the List.\n");
-      return;
-    }
-  char* tmpPName = new char[strlen(pName)];
-  strncpy(tmpPName, pName, strlen(pName)-1);
-  tmpPName[strlen(pName)-1] = '\0';
-  if (access (tmpPName, F_OK) == 0)
-    {
-      struct stat status;
-      stat(tmpPName, &status);
-      if (status.st_mode & S_IFDIR)
-	{
-	  PRINTF(4)("Adding Path %s to the PathList.\n", pName);
-	  PathList* tmpPathList = this;
-	  while (tmpPathList->next)
-	    tmpPathList = tmpPathList->next;
-	  tmpPathList->next = new PathList(pName);
-	}
-      else
-	PRINTF(2)("You tried to add non-folder %s to a PathList.\n", tmpPName);
-    }
-  else
-      PRINTF(2)("You tried to add non-existing folder %s to a PathList.\n", tmpPName);
-  delete []tmpPName;
-}
-
-
+#include "graphics_engine.h"
 
 /**
@@ -127,4 +34,16 @@
   this->texture = 0;
 }
+
+/**
+   \brief Constructor for a Texture
+*/
+Texture::Texture(const char* imageName)
+{
+  this->pImage = new Image;
+  this->pImage->data = NULL;
+  this->map = NULL;
+  this->texture = 0;
+  this->loadImage(imageName);
+}  
 
 /**
@@ -143,37 +62,4 @@
 
 /**
-   \brief Searches for a Texture inside one of the defined Paths
-   \param texName The name of the texture o search for.
-   \returns pathName+texName if texName was found in the pathList. NULL if the Texture is not found.
-*/
-char* Texture::searchTextureInPaths(char* texName) const
-{
-  char* tmpName = NULL;
-  PathList* pList = PathList::getInstance();
-  while (pList)
-    {
-      if (pList->pathName)
-	{
-	  tmpName = new char [strlen(pList->pathName)+strlen(texName)+1];
-	  strcpy(tmpName, pList->pathName);
-	}
-      else
-	{
-	  tmpName = new char [strlen(texName)+1];
-	  tmpName[0]='\0';
-	}
-      strcat(tmpName, texName);
-      if (access (tmpName, F_OK) == 0)
-	return tmpName;
-      
-      if (tmpName)
-	delete []tmpName;
-      tmpName = NULL;
-      pList = pList->next;
-    }
-  return NULL;
-}
-
-/**
    \brief a Simple function that switches two char values
    \param a The first value
@@ -195,61 +81,65 @@
 bool Texture::loadTexToGL (Image* pImage)
 {
-  PRINTF(4)("Loading texture to OpenGL-Environment.\n");
-  glGenTextures(1, &this->texture);
-  glBindTexture(GL_TEXTURE_2D, this->texture);
-  /* not Working, and not needed. 
-  glTexImage2D( GL_TEXTURE_2D, 0, 3, width,
-		height, 0, GL_BGR,
-		GL_UNSIGNED_BYTE, map->pixels );
-  */ 
-  gluBuild2DMipmaps(GL_TEXTURE_2D, 3, pImage->width, pImage->height, pImage->format, GL_UNSIGNED_BYTE, pImage->data);
-  
-  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_NEAREST);
-  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR_MIPMAP_LINEAR);	
-}
-
+  if (GraphicsEngine::texturesEnabled)
+    {
+      PRINTF(4)("Loading texture to OpenGL-Environment.\n");
+      glGenTextures(1, &this->texture);
+      glBindTexture(GL_TEXTURE_2D, this->texture);
+      /* not Working, and not needed. 
+	 glTexImage2D( GL_TEXTURE_2D, 0, 3, width,
+	 height, 0, GL_BGR,
+	 GL_UNSIGNED_BYTE, map->pixels );
+      */ 
+      gluBuild2DMipmaps(GL_TEXTURE_2D, 3, pImage->width, pImage->height, pImage->format, GL_UNSIGNED_BYTE, pImage->data);
+      
+      glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_NEAREST);
+      glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR_MIPMAP_LINEAR);	
+    }
+}
 
 #ifdef HAVE_SDL_SDL_IMAGE_H
-bool Texture::loadImage(char* imageName)
-{
-  char* imgNameWithPath = searchTextureInPaths(imageName);
-  if (imgNameWithPath)
-    {
-      this->map=IMG_Load(imgNameWithPath);
-      if(!map)
-	{
-	  PRINTF(1)("IMG_Load: %s\n", IMG_GetError());
+bool Texture::loadImage(const char* imageName)
+{
+  if (GraphicsEngine::texturesEnabled)
+    {
+      if (imageName)
+	{
+	  this->map=IMG_Load(imageName);
+	  if(!map)
+	    {
+	      PRINTF(1)("IMG_Load: %s\n", IMG_GetError());
+	      return false;
+	    }
+	  pImage->height = map->h;
+	  pImage->width  = map->w;
+	  pImage->data   = (GLubyte*)map->pixels;
+	  pImage->bpp    = map->format->BytesPerPixel;
+	  if (pImage->bpp == 3)
+	    pImage->format = GL_RGB;
+	  else if (pImage->bpp == 4)
+	    pImage->format = GL_RGBA;
+	  
+	  if( !IMG_isPNG(SDL_RWFromFile(imageName, "rb")) && !IMG_isJPG(SDL_RWFromFile(imageName, "rb")))
+	    for (int i=0;i<map->h * map->w *3;i+=3)
+	      { 
+		GLuint temp = pImage->data[i];
+		pImage->data[i] = pImage->data[i+2];
+		pImage->data[i+2] = temp;
+	      }
+	  /* this is the real swapping algorithm */
+	  for( int i = 0 ; i < (pImage->height / 2) ; ++i )
+	    for( int j = 0 ; j < pImage->width * pImage->bpp; j += pImage->bpp )
+	      for(int k = 0; k < pImage->bpp; ++k)
+		swap( pImage->data[ (i * pImage->width * pImage->bpp) + j + k], pImage->data[ ( (pImage->height - i - 1) * pImage->width * pImage->bpp ) + j + k]);
+	  
+	  this->loadTexToGL (this->pImage);
+	  SDL_FreeSurface(map);
+	  this->pImage->data = NULL;
+	}
+      else
+	{
+	  PRINTF(2)("Image not Found: %s\n", imageName);
 	  return false;
 	}
-      pImage->height = map->h;
-      pImage->width  = map->w;
-      pImage->data   = (GLubyte*)map->pixels;
-      pImage->bpp    = map->format->BytesPerPixel;
-      if (pImage->bpp == 3)
-	pImage->format = GL_RGB;
-      else if (pImage->bpp == 4)
-	pImage->format = GL_RGBA;
-	  
-      if( !IMG_isPNG(SDL_RWFromFile(imgNameWithPath, "rb")) && !IMG_isJPG(SDL_RWFromFile(imgNameWithPath, "rb")))
-	for (int i=0;i<map->h * map->w *3;i+=3)
-	  { 
-	    GLuint temp = pImage->data[i];
-	    pImage->data[i] = pImage->data[i+2];
-	    pImage->data[i+2] = temp;
-	  }
-      /* this is the real swapping algorithm */
-      for( int i = 0 ; i < (pImage->height / 2) ; ++i )
-	for( int j = 0 ; j < pImage->width * pImage->bpp; j += pImage->bpp )
-	  for(int k = 0; k < pImage->bpp; ++k)
-	    swap( pImage->data[ (i * pImage->width * pImage->bpp) + j + k], pImage->data[ ( (pImage->height - i - 1) * pImage->width * pImage->bpp ) + j + k]);
- 
-      this->loadTexToGL (this->pImage);
-      SDL_FreeSurface(map);
-      this->pImage->data = NULL;
-    }
-  else
-    {
-      PRINTF(2)("Image not Found: %s\n", imgNameWithPath);
-      return false;
     }
 }
@@ -262,43 +152,44 @@
    \todo Checks where to find the Image
 */
-bool Texture::loadImage(char* imageName)
-{
-  char* imgNameWithPath = searchTextureInPaths(imageName);
-  if (imgNameWithPath)
-    {
-      if (!strncmp(imgNameWithPath+strlen(imgNameWithPath)-4, ".bmp", 4))
-	{
-	  PRINTF(4)("Requested bmp-image. Trying to Import.\n");
-	  return this->loadBMP(imgNameWithPath);
-	}
-      
-      else if (!strncmp(imgNameWithPath+strlen(imgNameWithPath)-4, ".jpg", 4) || !strncmp(imgNameWithPath+strlen(imgNameWithPath)-5, ".jpg", 5))
-	{
-	  PRINTF(4)("Requested jpeg-image. Trying to Import\n");
-	  return this->loadJPG(imgNameWithPath);
-	}
-      else if (!strncmp(imgNameWithPath+strlen(imgNameWithPath)-4, ".tga", 4))
-	{
-	  PRINTF(4)("Requested tga-image. Trying to Import\n");
-	  return this->loadTGA(imgNameWithPath);
-	}
-      else if (!strncmp(imgNameWithPath+strlen(imgNameWithPath)-4, ".png", 4))
-	{
-	  PRINTF(4)("Requested png-image. Trying to Import\n");
-	  return this->loadPNG(imgNameWithPath);
+bool Texture::loadImage(const char* imageName)
+{
+  if (GraphicsEngine::texturesEnabled)
+    {
+      if (imageName)
+	{
+	  if (!strncmp(imageName+strlen(imageName)-4, ".bmp", 4))
+	    {
+	      PRINTF(4)("Requested bmp-image. Trying to Import.\n");
+	      return this->loadBMP(imageName);
+	    }
+	  
+	  else if (!strncmp(imageName+strlen(imageName)-4, ".jpg", 4) || !strncmp(imageName+strlen(imageName)-5, ".jpg", 5))
+	    {
+	      PRINTF(4)("Requested jpeg-image. Trying to Import\n");
+	      return this->loadJPG(imageName);
+	    }
+	  else if (!strncmp(imageName+strlen(imageName)-4, ".tga", 4))
+	    {
+	      PRINTF(4)("Requested tga-image. Trying to Import\n");
+	      return this->loadTGA(imageName);
+	    }
+	  else if (!strncmp(imageName+strlen(imageName)-4, ".png", 4))
+	    {
+	      PRINTF(4)("Requested png-image. Trying to Import\n");
+	      return this->loadPNG(imageName);
+	    }
+	  else
+	    {
+	      PRINTF(2)("Requested Image was not recognized in its type. (Maybe a type-Cast-error.)\n FileName: %s", imageName);
+	      return false;
+	    }
 	}
       else
 	{
-	  PRINTF(2)("Requested Image was not recognized in its type. (Maybe a type-Cast-error.)\n FileName: %s", imgNameWithPath);
+	  PRINTF(2)("Image not Found: %s\n", imageName);
 	  return false;
 	}
     }
-  else
-    {
-      PRINTF(2)("Image not Found: %s\n", imgNameWithPath);
-      return false;
-    }
-}
-
+}
 /**
    \brief reads in a Windows BMP-file, and imports it to openGL.
Index: orxonox/branches/levelloader/src/lib/graphics/importer/texture.h
===================================================================
--- orxonox/branches/levelloader/src/lib/graphics/importer/texture.h	(revision 3606)
+++ orxonox/branches/levelloader/src/lib/graphics/importer/texture.h	(revision 3746)
@@ -28,28 +28,4 @@
 #endif /* HAVE_SDL_SDL_IMAGE_H */
 
-
-
-//! Class to handle lists of paths.
-/**
-   \todo Ability to return Paths by itself.
-
-   It is simple to use, and good, for all PathList you want.
-   just create a new Pathlist, and add Paths.
-*/
-class PathList
-{
- private:
-  PathList();
-  static PathList* firstPath; //!< A static Pointer to the first PathList in the List.
- public:
-  PathList(char* pName);
-  ~PathList();
-  static PathList* getInstance(void);
-  
-  void addPath (char* pName);
-  char* pathName;              //!< The Name of the current Path.
-  PathList* next;              //!< Pointer to the next Pathlist.
-};
-
 //! A Class, that reads in Textures from different fileformats.
 class Texture
@@ -70,8 +46,9 @@
   GLuint texture;   //!< The Texture-ID of opengl from this Texture.
   SDL_Surface* map; //!< The map SDL initializes for this element.
-  char* searchTextureInPaths(char* texName) const;
+  char* searchTextureInPaths(const char* texName) const;
   inline void swap(unsigned char &a, unsigned char &b);
  public:
   Texture(void);
+  Texture(const char* imageName);
   ~Texture(void);
   /** \returns The textureID of this texture.  */
@@ -79,5 +56,5 @@
   bool loadTexToGL (Image* pImage);
 
-  bool loadImage(char* imageName);
+  bool loadImage(const char* imageName);
 #ifndef HAVE_SDL_SDL_IMAGE_H
 
Index: orxonox/branches/levelloader/src/lib/graphics/light.cc
===================================================================
--- orxonox/branches/levelloader/src/lib/graphics/light.cc	(revision 3606)
+++ orxonox/branches/levelloader/src/lib/graphics/light.cc	(revision 3746)
@@ -21,4 +21,5 @@
 
 #include "glincl.h"
+#include "vector.h"
 
 using namespace std;
Index: orxonox/branches/levelloader/src/lib/gui/gui/Makefile.am
===================================================================
--- orxonox/branches/levelloader/src/lib/gui/gui/Makefile.am	(revision 3606)
+++ orxonox/branches/levelloader/src/lib/gui/gui/Makefile.am	(revision 3746)
@@ -21,5 +21,5 @@
 
 #AM_LDFLAGS=$(GTK2_LIBS)   $(GTHREAD_LIBS)
-LIBS=$(GTK2_LIBS) $(GTHREAD_LIBS) $(CURL_LIBS)
+AM_LDFLAGS=$(GTK2_LIBS) $(GTHREAD_LIBS) $(CURL_LIBS)
 
 bin_PROGRAMS=gui
Index: orxonox/branches/levelloader/src/lib/gui/gui/orxonox_gui.cc
===================================================================
--- orxonox/branches/levelloader/src/lib/gui/gui/orxonox_gui.cc	(revision 3606)
+++ orxonox/branches/levelloader/src/lib/gui/gui/orxonox_gui.cc	(revision 3746)
@@ -95,5 +95,5 @@
 
   // Reading Values from File
-  exec->setFilename("~/.orxonox.conf");
+  exec->setConfFile("~/.orxonox/orxonox.conf");
   exec->readFromFile(orxonoxGUI);
   // Merging changes to the Options from appended flags.
